# Time-stamp: <05/09/09 21:56:22 ptr>
# $Id$

.SUFFIXES:
.SCCS_GET:
.RCS_GET:

PHONY ?=

OBJ_EXT ?= o

RULESBASE ?= $(SRCROOT)/Makefiles

ALL_TAGS ?= all-shared

all:	$(OUTPUT_DIRS) $(ALL_TAGS)

all-static: release-static dbg-static stldbg-static
all-shared: release-shared dbg-shared stldbg-shared

install-shared: install-dbg-shared install-stldbg-shared install-release-shared
install-static: install-dbg-static install-stldbg-static install-release-static

# include file, generated by configure, if available
-include ${RULESBASE}/config.mak
# define what make clone we use
include ${RULESBASE}/make.mak
ifndef OSNAME
# identify OS and build date
include ${RULESBASE}/$(USE_MAKE)/sysid.mak
endif
# OS-specific definitions, like ln, install, etc. (guest host)
include ${RULESBASE}/$(USE_MAKE)/$(BUILD_OSNAME)/sys.mak
# target OS-specific definitions, like ar, etc.
include ${RULESBASE}/$(USE_MAKE)/$(OSNAME)/targetsys.mak
# compiler, compiler options
include ${RULESBASE}/$(USE_MAKE)/$(COMPILER_NAME).mak
# rules to make dirs for targets
include ${RULESBASE}/$(USE_MAKE)/targetdirs.mak
# extern libraries
include ${RULESBASE}/$(USE_MAKE)/$(OSNAME)/extern.mak

# os-specific local rules
-include specific.mak

# derive common targets (*.o, *.d),
# build rules (including output catalogs)
include ${RULESBASE}/$(USE_MAKE)/targets.mak
# dependency
ifneq ($(OSNAME),windows)
include ${RULESBASE}/$(USE_MAKE)/depend.mak
endif

# general clean
include ${RULESBASE}/clean.mak

# if target is library, rules for library
ifdef LIBNAME
include ${RULESBASE}/$(USE_MAKE)/lib/top.mak
endif

# if target is program, rules for executable
ifdef PRGNAME
include ${RULESBASE}/$(USE_MAKE)/app/top.mak
endif

.PHONY: $(PHONY)
